Documentation/git-sh-setup.txt: programmer's docs
[gitweb.git] / git-sh-setup.sh
index 4a02b3825ecc15cb289a1dadb328e39a1869f3f1..6b1c1423ebb7fde53aae566fa09211d331c422bc 100755 (executable)
@@ -36,6 +36,17 @@ is_bare_repository () {
        esac
 }
 
+cd_to_toplevel () {
+       cdup=$(git-rev-parse --show-cdup)
+       if test ! -z "$cdup"
+       then
+               cd "$cdup" || {
+                       echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
+                       exit 1
+               }
+       fi
+}
+
 require_work_tree () {
        test $(is_bare_repository) = false ||
        die "fatal: $0 cannot be used without a working tree."
@@ -60,7 +71,11 @@ esac
 if [ -z "$SUBDIRECTORY_OK" ]
 then
        : ${GIT_DIR=.git}
-       GIT_DIR=$(GIT_DIR="$GIT_DIR" git-rev-parse --git-dir) || exit
+       GIT_DIR=$(GIT_DIR="$GIT_DIR" git-rev-parse --git-dir) || {
+               exit=$?
+               echo >&2 "You need to run this command from the toplevel of the working tree."
+               exit $exit
+       }
 else
        GIT_DIR=$(git-rev-parse --git-dir) || exit
 fi